
# linux host below
# vagrant destroy -f && rm -rf .vagrant && vagrant up
# windows host below
# vagrant destroy -f; del -Recurse .vagrant; vagrant up
Vagrant.configure("2") do |config|

    config.vm.define "pemrplugindev" do |node|
        node.vm.box = "generic/ubuntu2004"
        node.vm.synced_folder '.', "/vagrant", disabled: true
        node.vm.hostname = "pemr-plugin-dev"
        node.vm.network "private_network", ip: "192.168.60.10"
        node.vm.provider "virtualbox" do |vb|
            vb.cpus = 4
            vb.memory = 8192
            vb.gui = false
        end
        node.vm.provision "shell", inline: <<-PerformSetup
            echo "********************************"
            echo "* converting server to dev lab *"
            echo "********************************"
            echo "**** installing interactive ****"
            apt-get update -q
            echo "**** installing dev tools ****"
            apt-get install -yq openssh-server net-tools git build-essential cmake python3-wheel python3-dev python3-pip docker.io
            apt-get install -yq libxi6 libxtst6 x11-apps
            sed -i 's/#X11UseLocalhost yes/X11UseLocalhost no/g' /etc/ssh/sshd_config
            usermod -aG docker vagrant
            echo "**** installing ide of choice ****"
            echo snap install pycharm-community --classic
            echo "**** preparing dev env ****"
        PerformSetup
        node.vm.provision "file", source: "context/initial-setup.sh", destination: "/home/vagrant/initial-setup.sh"
        node.vm.provision "file", source: "context/setup-local-pemr-plugin-dev.sh", destination: "/home/vagrant/setup-local-pemr-plugin-dev.sh"
        node.vm.provision "file", source: "context/teardown-local-pemr-plugin-dev.sh", destination: "/home/vagrant/teardown-local-pemr-plugin-dev.sh"
        node.vm.provision "file", source: "context/bootstrap-plugin-dev-folder.sh", destination: "/home/vagrant/bootstrap-plugin-dev-folder.sh"
        node.vm.provision "file", source: "context/cloud-deploy/ensure-dependencies.sh", destination: "/home/vagrant/cloud-deploy/ensure-dependencies.sh"
        node.vm.provision "shell", inline: <<-ExecPerm
            chmod +x /home/vagrant/*.sh
            chmod +x /home/vagrant/cloud-deploy/*.sh
        ExecPerm
    end
end
